/* RCS $Id: j_exp.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: j_exp.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:26:20  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_intv j_exp(a_intv x)                */
/*                        a_intv x  ;                           */
/*                                                              */
/*      Arguments       : x = interval argument of exp(x)       */
/*                                                              */
/*      Description     : Fast interval exponential function    */
/*                        for double IEEE Floating-Point        */
/*                        Arithmetic                            */
/*                                                              */
/*      Date            : 1996-03-08                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local a_intv j_exp(a_intv x)
#else
local a_intv j_exp(x)

a_intv x;
#endif
{
  a_intv res;
  if (x.INF==x.SUP)                        /* point interval */
    { 
      if (x.INF==0) 
        res.INF=res.SUP=1.0;
      else if (x.INF<=q_mine)
        { 
          res.INF=0.0;
          res.SUP=q_minr;
        }
      else 
        { 
          res.INF=q_exp(x.INF);
          res.SUP=res.INF*q_exep;
          res.INF*=q_exem;
        }
    }
  else
    {
      if (x.INF<=q_mine) 
        res.INF=0.0;
      else 
        res.INF=q_exp(x.INF)*q_exem;
      if (x.SUP<=q_mine)
        res.SUP=q_minr;
      else
        res.SUP=q_exp(x.SUP)*q_exep;
    }   
  if (res.INF<0.0) res.INF=0.0;
  if ((x.SUP<=0.0) && (res.SUP>1.0)) res.SUP=1.0;
  if ((x.INF>=0.0) && (res.INF<1.0)) res.INF=1.0;
  return(res);
}

